
from src.replacers.email_replacer import EmailReplacer
from src.annotations import DateAnnotation, CityAnnotation, UserAnnotation, EmailAnnotation

def test_email_replacer():
    text = "zz@z.pl urodziła sie 05.05.2005 we Wrocławiu"
    detections = [
        (0, 7, EmailAnnotation()), 
        (21, 31, DateAnnotation()),
        (35, 44, CityAnnotation()),
    ]
    
    replacer = EmailReplacer()
    result = replacer.replace(text, detections)
    
    expected_text_ending = " urodziła sie 05.05.2005 we Wrocławiu"
    exptected_detections_left = [
        (len(result[0]) - 23, len(result[0]) - 13, DateAnnotation()),
        (len(result[0]) - 9, len(result[0]), CityAnnotation()),
    ]
    
    assert result[0].endswith(expected_text_ending)
    assert result[0][0:-len(expected_text_ending)] != "zz@z.pl"
    assert result[1] == exptected_detections_left
    
def test_email_replacer_same_email_same_replacement():
    text = "zz@z.pl zz@z.pl aa@a.pl"
    detections = [
        (0, 7, EmailAnnotation()), 
        (8, 15, EmailAnnotation()),
        (16, 22, EmailAnnotation()),
        
    ]
    
    replacer = EmailReplacer()
    result = replacer.replace(text, detections)
    
    old_emails = text.split()
    new_emails = result[0].split()
    
    assert old_emails[0] != new_emails[0]
    assert new_emails[0] == new_emails[1]
    assert result[1] == []