
from src.replacers.tag_replacer import TagReplacer
from src.annotations import NameAnnotation, SurnameAnnotation, DateAnnotation, CityAnnotation

def test_replace_with_tags():
    text = "Ala Brzeszczot urodziła sie 05.05.2005 we Wrocławiu"
    detections = [
        (0, 3, NameAnnotation()), 
        (4, 14, SurnameAnnotation()),
        (28, 38, DateAnnotation()),
        (42, 51, CityAnnotation()),
    ]
    
    replacer = TagReplacer()
    
    result = replacer.replace(text, detections)
    
    expected_text = "[OSOBA] [OSOBA] urodziła sie [DATE] we [MIEJSCE]"
    exptected_detections_left = []
    
    assert result == (expected_text, exptected_detections_left)